//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Client.MetadataConsumerTest
{
    
    
    /// <summary>
    /// Response type for the Echo String And Structure Metadata command
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("Echo String And Structure Metadata - Response")]
    public struct UnpackMetadataResponse
    {
        
        private string _receivedString;
        
        private long _firstReceivedInteger;
        
        private long _secondReceivedInteger;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public UnpackMetadataResponse(string receivedString, long firstReceivedInteger, long secondReceivedInteger)
        {
            _receivedString = receivedString;
            _firstReceivedInteger = firstReceivedInteger;
            _secondReceivedInteger = secondReceivedInteger;
        }
        
        /// <summary>
        /// The received string (via "String Metadata")
        /// </summary>
        public string ReceivedString
        {
            get
            {
                return _receivedString;
            }
        }
        
        /// <summary>
        /// The first element of the received integer structure (via "Two Integers Metadata")
        /// </summary>
        public long FirstReceivedInteger
        {
            get
            {
                return _firstReceivedInteger;
            }
        }
        
        /// <summary>
        /// The second element of the received integer structure (via "Two Integers Metadata")
        /// </summary>
        public long SecondReceivedInteger
        {
            get
            {
                return _secondReceivedInteger;
            }
        }
    }
    
    /// <summary>
    /// This feature consumes SiLA Client Metadata from the "Metadata Provider Test" feature.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("MetadataConsumerTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Metadata Consumer Test")]
    public partial interface IMetadataConsumerTest
    {
        
        /// <summary>
        /// Expects the "String Metadata" metadata from the "Metadata Provider" feature and returns the metadata value.
        /// </summary>
        string ReceivedStringMetadata
        {
            get;
        }
        
        /// <summary>
        /// Expects the "String Metadata" metadata from the "Metadata Provider" feature and returns all characters of its string value as separate responses.
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        string ReceivedStringMetadataAsCharacters
        {
            get;
        }
        
        /// <summary>
        /// Expects the "String Metadata" metadata from the "Metadata Provider Test" feature and responds with its value.
        /// </summary>
        /// <returns>The received string metadata</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedStringMetadata")]
        string EchoStringMetadata();
        
        /// <summary>
        /// Expects the "String Metadata" and "Two Integers Metadata" metadata from the "Metadata Provider Test" feature and responds with all three data items.
        /// </summary>
        /// <returns>The received string (via "String Metadata"), The first element of the received integer structure (via "Two Integers Metadata"), The second element of the received integer structure (via "Two Integers Metadata")</returns>
        [Tecan.Sila2.SilaDisplayNameAttribute("Echo String And Structure Metadata")]
        [return: Tecan.Sila2.InlineStructAttribute()]
        UnpackMetadataResponse UnpackMetadata();
    }
}
